//
//  EAGLView.h
//  Hw4
//
//  Created by SJSU Student on 25.11.09.
//  Copyright 2009 SJSU Student . All rights reserved.
//

#import <UIKit/UIKit.h>
#import <OpenGLES/EAGL.h>
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>

@interface EAGLView : UIView {

@private
    /* The pixel dimensions of the backbuffer */
    GLint backingWidth;
    GLint backingHeight;
    
    EAGLContext *context;
    
    /* OpenGL names for the renderbuffer and framebuffers used to render to this view */
    GLuint viewRenderbuffer, viewFramebuffer;
    
    /* OpenGL name for the depth buffer that is attached to viewFramebuffer, if it exists (0 if it does not exist) */
    GLuint depthRenderbuffer;
    
    NSTimer *animationTimer;
    NSTimeInterval animationInterval;
	GLfloat zValueForZoom; 
	
	
	/* BOOLs that is used to decide what direction the rotation will be done in */
	CGPoint currentTouchPosition;
	CGPoint startTouchPosition;
	CGPoint lastTouchPosition;
	IBOutlet UILabel *label; 
	int points; 
	BOOL doExplode;
	int explotionLength;
}

@property NSTimeInterval animationInterval;
@property (nonatomic, retain) EAGLContext *context;
@property (nonatomic, assign) NSTimer *animationTimer;
@property (nonatomic, assign) UILabel *label; 

- (BOOL)createFramebuffer;
- (void)destroyFramebuffer;
- (void)startAnimation;
- (void)stopAnimation;
- (void)drawView;
- (void)reset3D;

- (void)setupView;
- (void)checkGLError:(BOOL)visibleCheck;
- (CGFloat)distanceBetweenTwoPoints:(CGPoint)fromPoint toPoint:(CGPoint)toPoint;


@end
