//
//  EAGLView.m
//  Hw4
//
//  Created by SJSU Students on 25.11.09.
//  Copyright 2009 SJSU Students . All rights reserved.
//

#import <QuartzCore/QuartzCore.h>
#import <OpenGLES/EAGLDrawable.h>
#import "EAGLView.h"
#import "Hw4AppDelegate.h"

#define USE_DEPTH_BUFFER 1
#define DEGREES_TO_RADIANS(__ANGLE) ((__ANGLE) / 180.0 * M_PI)



@implementation EAGLView

@synthesize context;
@synthesize animationTimer;
@synthesize animationInterval;
@synthesize label;

/* Set the start angles */

currentTouchPosition=0.0;
startTouchPosition=0.0; 
lastTouchPosition=0.0;
UITouch *touch1;
UITouch *touch2;
CGFloat prev;
CGFloat current;
doExplode=NO;
explotionLength=0;

/* Code for my 3D Cylinder */
GLfloat frontCircle[33];            // Now have X, y, Z

GLfloat rearCircle[33];
GLfloat side[12];

float radius = 0.5;

GLfloat origin[2] = {
	
	0.0, 0.0
	
};

	
+ (Class)layerClass {
    return [CAEAGLLayer class];
}


//The GL view is stored in the nib file. When it's unarchived it's sent -initWithCoder:
- (id)initWithCoder:(NSCoder*)coder{
    
    if ((self = [super initWithCoder:coder])) {
        // Get the layer
        CAEAGLLayer *eaglLayer = (CAEAGLLayer *)self.layer;
        
        eaglLayer.opaque = YES;
        eaglLayer.drawableProperties = [NSDictionary dictionaryWithObjectsAndKeys:
                                        [NSNumber numberWithBool:NO], kEAGLDrawablePropertyRetainedBacking, kEAGLColorFormatRGBA8, kEAGLDrawablePropertyColorFormat, nil];
        
        context = [[EAGLContext alloc] initWithAPI:kEAGLRenderingAPIOpenGLES1];
        
        if (!context || ![EAGLContext setCurrentContext:context]) {
            [self release];
            return nil;
        }
        
        animationInterval = 1.0 / 60.0;
		
		// Set the default distance of the object on the Z axis
		zValueForZoom = -6.0;
		points=0;
		[self setupView];
    }
    return self;
}


/* Code for drawing the 3D View */
- (void)drawView {
    
    [EAGLContext setCurrentContext:context];    
    glBindFramebufferOES(GL_FRAMEBUFFER_OES, viewFramebuffer);
    glViewport(0, 0, backingWidth, backingHeight);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	//Tell openGL that we are working in ModelView
	glMatrixMode(GL_MODELVIEW);
	
	/* Drawing code for the Cylinder */
	
	
    int i = 0;
	
    for (float angle = 0; angle < 2*M_PI; angle += 0.630) {
		
        frontCircle[i] = origin[0] + radius * cos(angle);       // X
		
        frontCircle[i+1] = origin[1] + radius * sin(angle);     // Y
		
        frontCircle[i+2] = 2.0;           // Z, somewhere off behind the viewer
		
		
		
        rearCircle[i] = frontCircle[i];
		
        rearCircle[i+1] = frontCircle[i+1];
		
        rearCircle[i+2] = -2.0;           // Off in front of us
		
        i += 3;
		
    }
	
	
	
    frontCircle[30] = frontCircle[0];
	
    frontCircle[31] = frontCircle[1];
	
    frontCircle[32] = frontCircle[2];
	
    rearCircle[30] = rearCircle[0];
	
    rearCircle[31] = rearCircle[1];
	
    rearCircle[32] = rearCircle[2];
	
	
	
    glPushMatrix();
	
	if (doExplode!=YES) {
	/* Draw frontCircle */
    glVertexPointer(3, GL_FLOAT, 0, frontCircle);
	glEnableClientState(GL_VERTEX_ARRAY);
    glColor4f(0.5, 0.5, 1.0, 1.0);
    glDrawArrays(GL_TRIANGLE_FAN, 0, 10);
	
	/* Draw rearCircle  */
    glVertexPointer(3, GL_FLOAT, 0, rearCircle);
    glColor4f(0.5, 0.9, 1.0, 1.0);
    glDrawArrays(GL_TRIANGLE_FAN, 0, 10);
	}
	
	/*  Code for Explosion  */
	else if(explotionLength<10000 && doExplode==YES){
		
		
		/* Draw frontCircle */
		glVertexPointer(3, GL_FLOAT, 0, frontCircle);
		glEnableClientState(GL_VERTEX_ARRAY);
		glColor4f(0.5, 0.5, 1.0, 1.0);
		glDrawArrays(GL_POINTS, 0, 10);
		
		/* Draw rearCircle  */
		glVertexPointer(3, GL_FLOAT, 0, rearCircle);
		glColor4f(0.5, 0.9, 1.0, 1.0);
		glDrawArrays(GL_POINTS, 0, 10);
		
	}

	

    glVertexPointer(3, GL_FLOAT, 0, side);
    glColor4f(0.45, 0.0, 0.9, 1.0);
	
	
    for (int i = 0; i < 10; i++) {
		
        side[0] = frontCircle[i*3];
		
        side[1] = frontCircle[i*3+1];
		
        side[2] = frontCircle[i*3+2];
		
		
		
        side[3] = frontCircle[i*3+3];
		
        side[4] = frontCircle[i*3+4];
		
        side[5] = frontCircle[i*3+5];
		
		
		
        side[6] = rearCircle[i*3];
		
        side[7] = rearCircle[i*3+1];
		
        side[8] = rearCircle[i*3+2];
		
		
		
        side[9] = rearCircle[i*3+3];
		
        side[10] = rearCircle[i*3+4];
		
        side[11] = rearCircle[i*3+5];
	
		if (doExplode!=YES) {
        glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);
		}
		else if(explotionLength<10000 && doExplode==YES){
			if (explotionLength<500) {
			glDrawArrays(GL_POINTS, 1, 9);
			if (explotionLength>350) {
				glRotatef(explotionLength*0.001, 1.0, 1.0, 1.0);

			}
			}
			else {
				glDrawArrays(GL_TRIANGLE_STRIP, 0, 2);
				glRotatef(explotionLength*0.001, 1.0, 1.0, 1.0);
				
			}

			explotionLength++;
			radius+=0.005;
		}
		if (explotionLength==9999) {
			explotionLength=0;
			doExplode=NO;
		}
		
    }
	/* End of drawing code */
	
    
    glBindRenderbufferOES(GL_RENDERBUFFER_OES, viewRenderbuffer);
    [context presentRenderbuffer:GL_RENDERBUFFER_OES];
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
	
	NSLog(@"touchesBegan \n");
    UITouch *touch = [touches anyObject];
	
    // startTouchPosition is an instance variable	
	startTouchPosition = [touch locationInView:self];
	
	
}


- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
	NSLog(@"touchesMoved \n");
	glMatrixMode(GL_MODELVIEW);
	
	/* Logic that handles multitouch */
	if([touches count]>1){
		NSLog(@"Multible Touch!");
		touch1 = [[touches allObjects] objectAtIndex:0];
		touch2 = [[touches allObjects] objectAtIndex:1];
		
		prev = [ self distanceBetweenTwoPoints:[touch1 previousLocationInView:self] toPoint:[touch2 previousLocationInView:self]];
		current = [ self distanceBetweenTwoPoints:[touch1 locationInView:self] toPoint:[touch2 locationInView:self]];
		
	} 
	else{touch1 = [touches anyObject];}  // there is only one touch
	
	/* Code for zooming in and out */
	NSLog(@"Amount of touches: %i",[touches count]);
	if ([touches count]>1){
		
		if (prev<current) {
			NSLog(@"Zoom in \n");
			
			glScalef(1.05, 1.05, 1.05);
		}
		else if (prev>current){
			NSLog(@"Zoom out \n");
			glScalef(0.95, 0.95, 0.95);
		}
		
	}
	
	
	currentTouchPosition = [touch1 locationInView:self];
	lastTouchPosition = [touch1 previousLocationInView:self];
	
	
	/* Code for rotating around X and Y axis */
	if ([touches count]==1){
		
		if ((lastTouchPosition.x-currentTouchPosition.x)>0){
			glRotatef(-2.0, 0.0, 1.0, 0.0);
		}
		else if ((lastTouchPosition.x-currentTouchPosition.x)<0){
			glRotatef(2.0, 0.0, 1.0, 0.0);
		}
		
		if ((lastTouchPosition.y-currentTouchPosition.y)>0) {
			glRotatef(-2.0, 1.0, 0.0, 0.0);
			
		}
		else if ((lastTouchPosition.y-currentTouchPosition.y)<0) {
			glRotatef(2.0, 1.0, 0.0, 0.0);
			NSLog(@"Rotating along Y axis\n"); 
			
		}
		
	}
	
	
	
	
	
}

// Returns distance between fromPoint and toPoint
- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
	NSLog(@"touchesEnded \n");
	
	UITouch *touch = [[touches allObjects] objectAtIndex:0];
			
			switch([touch tapCount])
			{
				case 1://Single tap
					NSLog(@"Single tap!");
					break;
				case 2://Double tap.
					NSLog(@"Double tap!");
					points++;
					label.text=[[NSString alloc] initWithFormat:@"Points: %i",points]; 
					NSLog(@"Label: %@",label.text);
					doExplode=YES;
					break;
			}
	
}



// Reset position of the object
-(void)reset3D{
	radius=0.5;
	doExplode=NO;
	explotionLength=0;
	glLoadIdentity();
	
}
- (CGFloat)distanceBetweenTwoPoints:(CGPoint)fromPoint toPoint:(CGPoint)toPoint {
	
	float x = toPoint.x - fromPoint.x;
	float y = toPoint.y - fromPoint.y;
	
	return sqrt(x * x + y * y);
}

- (void)layoutSubviews {
    [EAGLContext setCurrentContext:context];
    [self destroyFramebuffer];
    [self createFramebuffer];
    [self drawView];
}


- (BOOL)createFramebuffer {
    
    glGenFramebuffersOES(1, &viewFramebuffer);
    glGenRenderbuffersOES(1, &viewRenderbuffer);
    
    glBindFramebufferOES(GL_FRAMEBUFFER_OES, viewFramebuffer);
    glBindRenderbufferOES(GL_RENDERBUFFER_OES, viewRenderbuffer);
    [context renderbufferStorage:GL_RENDERBUFFER_OES fromDrawable:(CAEAGLLayer*)self.layer];
    glFramebufferRenderbufferOES(GL_FRAMEBUFFER_OES, GL_COLOR_ATTACHMENT0_OES, GL_RENDERBUFFER_OES, viewRenderbuffer);
    
    glGetRenderbufferParameterivOES(GL_RENDERBUFFER_OES, GL_RENDERBUFFER_WIDTH_OES, &backingWidth);
    glGetRenderbufferParameterivOES(GL_RENDERBUFFER_OES, GL_RENDERBUFFER_HEIGHT_OES, &backingHeight);
    
    if (USE_DEPTH_BUFFER) {
        glGenRenderbuffersOES(1, &depthRenderbuffer);
        glBindRenderbufferOES(GL_RENDERBUFFER_OES, depthRenderbuffer);
        glRenderbufferStorageOES(GL_RENDERBUFFER_OES, GL_DEPTH_COMPONENT16_OES, backingWidth, backingHeight);
        glFramebufferRenderbufferOES(GL_FRAMEBUFFER_OES, GL_DEPTH_ATTACHMENT_OES, GL_RENDERBUFFER_OES, depthRenderbuffer);
    }
    
    if(glCheckFramebufferStatusOES(GL_FRAMEBUFFER_OES) != GL_FRAMEBUFFER_COMPLETE_OES) {
        NSLog(@"failed to make complete framebuffer object %x", glCheckFramebufferStatusOES(GL_FRAMEBUFFER_OES));
        return NO;
    }
    
    return YES;
}

- (void)setupView {
	
    const GLfloat zNear = 0.1, zFar = 1000.0, fieldOfView = 60.0;
    GLfloat size;
    glEnable(GL_DEPTH_TEST);
    glMatrixMode(GL_PROJECTION);
    size = zNear * tanf(DEGREES_TO_RADIANS(fieldOfView) / 2.0);
	
	// This give us the size of the iPhone display
    CGRect rect = self.bounds;
    glFrustumf(-size, size, -size / (rect.size.width / rect.size.height), size / (rect.size.width / rect.size.height), zNear, zFar);
    glViewport(0, 0, rect.size.width, rect.size.height);
	
    glClearColor(0.0f, 0.0f, 0.0f, 1.0f);	
	glTranslatef(0.0, 0.0, zValueForZoom);
	self.multipleTouchEnabled = YES;
}

- (void)destroyFramebuffer {
    
    glDeleteFramebuffersOES(1, &viewFramebuffer);
    viewFramebuffer = 0;
    glDeleteRenderbuffersOES(1, &viewRenderbuffer);
    viewRenderbuffer = 0;
    
    if(depthRenderbuffer) {
        glDeleteRenderbuffersOES(1, &depthRenderbuffer);
        depthRenderbuffer = 0;
    }
}


- (void)startAnimation {
    self.animationTimer = [NSTimer scheduledTimerWithTimeInterval:animationInterval target:self selector:@selector(drawView) userInfo:nil repeats:YES];
}


- (void)stopAnimation {
    self.animationTimer = nil;
}


- (void)setAnimationTimer:(NSTimer *)newTimer {
    [animationTimer invalidate];
    animationTimer = newTimer;
}


- (void)setAnimationInterval:(NSTimeInterval)interval {
    
    animationInterval = interval;
    if (animationTimer) {
        [self stopAnimation];
        [self startAnimation];
    }
}

- (void)checkGLError:(BOOL)visibleCheck {
    GLenum error = glGetError();
    
    switch (error) {
        case GL_INVALID_ENUM:
            NSLog(@"GL Error: Enum argument is out of range");
            break;
        case GL_INVALID_VALUE:
            NSLog(@"GL Error: Numeric value is out of range");
            break;
        case GL_INVALID_OPERATION:
            NSLog(@"GL Error: Operation illegal in current state");
            break;
        case GL_STACK_OVERFLOW:
            NSLog(@"GL Error: Command would cause a stack overflow");
            break;
        case GL_STACK_UNDERFLOW:
            NSLog(@"GL Error: Command would cause a stack underflow");
            break;
        case GL_OUT_OF_MEMORY:
            NSLog(@"GL Error: Not enough memory to execute command");
            break;
        case GL_NO_ERROR:
            if (visibleCheck) {
                NSLog(@"No GL Error");
            }
            break;
        default:
            NSLog(@"Unknown GL Error");
            break;
    }
}


- (void)dealloc {
    
    [self stopAnimation];
    
    if ([EAGLContext currentContext] == context) {
        [EAGLContext setCurrentContext:nil];
    }
    
    [context release];  
    [super dealloc];
}


@end
